import random
import math
import turtle

#print(math.sqrt(2))
#print(math.atan2(1.,1.))

class Boid(turtle.Turtle):
    def __init__(self):
      super().__init__()
      self.speed(0)
      self.color(random.random(), random.random(), random.random())
      self.penup()
      self.goto(random.uniform(-200, 200), random.uniform(-200, 200))
      self.pendown()
    
    def drawSquare(self,edge):
      self.pendown()
      self.right(0)
      self.forward(edge)
      self.right(90)
      self.forward(edge)
      self.right(90)
      self.forward(edge)
      self.right(90)
      self.forward(edge)
      self.penup()
      
    def advance(self,x,y,distance):
      self.pendown()
      self.right(math.atan2(y,x)*180/math.pi)
      self.forward(distance)
      self.penup()
    
    def newAngle(self,positions,directions):
      neighbors = []
      for e in positions:
        if math.sqrt((e[0]-self.xcor())**2+(e[1]-self.ycor())**2)<50:
          neighbors.append(e)
      nCenter = (sum([e[0] for e in neighbors])/len(neighbors),sum([e[1] for e in neighbors])/len(neighbors))
      print("%s %s "%(nCenter,[self.xcor(),self.ycor()]))
      if len(neighbors)>1:
        return(180+math.atan2(nCenter[1]-self.ycor(),nCenter[0]-self.xcor())*180/math.pi)
      else: 
        center = (sum([e[0] for e in positions])/len(positions),sum([e[1] for e in positions])/len(positions))
        return(math.atan2(center[1]-self.ycor(),center[0]-self.xcor())*180/math.pi)
    
    def meanInformations(self,informations):
      mInfo = (sum([e[0] for e in informations])/len(informations),sum([e[1] for e in informations])/len(informations))
      return(mInfo)
    
    def goCenter(self,positions,distance):
      angle = self.newAngle(positions)
      print("--->%s"%angle)
      self.setheading(angle)
      self.forward(distance)
    
    def go(self,positions,directions,distance):
      self.pendown()
      angle = self.newAngle(positions,directions)
      print("--->%s"%angle)
      self.setheading(angle)
      self.forward(distance)
      self.penup()

if (__name__ == "__main__") :
  N = 20
  groupe = [Boid() for i in range(N)]
  centre_groupe = (sum([b.xcor() for b in groupe]) / N,sum([b.ycor() for b in groupe])/N)
  #print(centre_groupe)
  for b in groupe:
    b.drawSquare(10)
  for i in range(10):
    positions = [b.pos() for b in groupe]
    directions = [b.heading() for b in groupe]
    print(positions)
    for b in groupe:
      b.go(positions,directions,50)
  

  input()

