#!/usr/bin/python
# coding:utf-8

def pgcd(a,b):
  #if b == 0: 
  #  return(a)
  #else : 
  #  return(pgcd(b,a%b))
  while b!=0:
   c = b  
   b = a%b
   a = c
  return(a)

class Rational:
  """Rational numbers class."""

  def __init__(self, num, den):
    self.num = num
    self.den = den

  def __str__(self):
    return("{} / {}".format(self.num, self.den))

  def approx(self,dp):
    n = self.num 
    d = self.den
    s = str(n//d)+"."
    n = n%d
    for i in range(0,dp):
      s+=chr((n*10)//d+48)
      n = (n*10)%d
    return(s)

  def __add__(self, other):
    den = self.den * other.den
    num = (self.num * other.den + other.num * self.den)
    return(Rational(num, den))

  def __mul__(self, other):
    num = self.num * other.num
    den = self.den * other.den
    return(Rational(num, den))

  def __div__(self, other):
    num = self.num * other.den
    den = self.den * other.num
    return(Rational(num, den))
  
  def reduce(self):
    if self.den==0:
      raise(ZeroDivisionError)
    else:
      return(Rational(self.num//pgcd(self.num,self.den),self.den//pgcd(self.num,self.den)))


